/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Quickfile extension for Thunderbird.
 *
 * The Initial Developer of the Original Code is Paul Tomlin.
 * Portions created by the Initial Developer are Copyright (C) 2005, 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Paul Tomlin
 *  Mark Shuttleworth
 *
 * ***** END LICENSE BLOCK ***** */

/* $Id: overlayCommon.js,v 1.3 2006/11/19 23:39:51 paultomlin Exp $ */

const nsIPrefService = Components.interfaces.nsIPrefService;

function goQuickfileMove() {
  dump("goQuickfileMove()\n");

  goQuickfileWithMode('move');
}

function goQuickfileCopy() {
  dump("goQuickfileCopy()\n");

  goQuickfileWithMode('copy');
}

function goQuickfileInstaMove() {
  dump("goQuickfileInstaMove()\n");

  goQuickfileWithMode('instamove');
}

function goQuickfileInstaCopy() {
  dump("goQuickfileInstaCopy()\n");

  goQuickfileWithMode('instacopy');
}

function goQuickfileNavigate() {
  dump("goQuickfileNavigate()\n");

  goQuickfileWithMode('navigate');
}

function goQuickfileWithMode(aMode) {
  dump("goQuickfileWithMode(" + aMode + ")\n");

  var win = window.openDialog(
    "chrome://quickfile/content/quickfile.xul",
    "quickfileDialog",
    "chrome,resizable,centerscreen,modal", aMode);
}

function goUpdateQuickfileOverlays() {
  dump("goUpdateQuickfileOverlays()\n");

  var prefs = Components.classes["@mozilla.org/preferences-service;1"]
          .getService(nsIPrefService)
          .getBranch("quickfile.");

  var defaultFolderUri = null;
  if (prefs.getPrefType('defaultfolder.enable') == prefs.PREF_BOOL && prefs.getBoolPref('defaultfolder.enable'))
    if (prefs.getPrefType('defaultfolder.uri') == prefs.PREF_STRING)
      defaultFolderUri = prefs.getCharPref('defaultfolder.uri');

  var shortcuts = ['copy', 'move', 'instacopy', 'instamove', 'navigate'];
  for (var i in shortcuts) {
    var shortcut = shortcuts[i];
    var el = document.getElementById('key_quickfile_' + shortcut);
    if (! el)
      continue;

    var key = prefs.getCharPref('shortcuts.' + shortcut + '.key');
    var modifiers = prefs.getCharPref('shortcuts.' + shortcut + '.modifiers');
    if (key) {
      el.setAttribute('key', key);
      el.setAttribute('modifiers', modifiers);
      el.setAttribute('disabled', 'false');
    }
    else
      el.parentNode.removeChild(el);

    if (!defaultFolderUri && (shortcut == 'instamove' || shortcut == 'instacopy'))
      el.setAttribute('disabled', 'true');
  }
}
